//-----------------------------------------------------------------------------------------
//------------------------------ SISTEMA DE DEFESA  MACRO-4 -------------------------------
//-----------------------------------------------------------------------------------------

#include <math.h>
#include <AccelStepper.h>
#include <SoftwareSerial.h>

SoftwareSerial Bluetooth(51, 53); // Arduino(RX, TX) - HC-05 Bluetooth (TX, RX)

//Definir os motores de passo e os pinos que eles utilizarão
//(driver, STEP, DIR)
AccelStepper m1(1, 3, 2);  // Stepper1 = Esquerda frontal
AccelStepper m2(1, 5, 4); // Stepper2 = Direita frontal
AccelStepper m3(1, 7, 6); //Stepper 3 = Esquerda traseira
AccelStepper m4(1, 9, 8); // Stepper 4 = Direita traseira

int dataIn[8] {0, 0, 0, 0, 0, 0, 0}; //Array para armazenar todas as informações. 255, x, y, z, est, ang, fire.
int in_byte = 0;
int array_index = 0;

int ang;
int est;
int fire;
int vx;
int vy;
int w;

float v1;
float v2;
float v3;
float v4;

int V1;
int V2;
int V3;
int V4;

void setup() {
  
  Serial.begin(9600);
  Bluetooth.begin(9600);

  m1.setMaxSpeed(4000);
  m2.setMaxSpeed(4000);
  m3.setMaxSpeed(4000);
  m4.setMaxSpeed(4000);

  m1.setAcceleration(10000);
  m2.setAcceleration(10000);
  m3.setAcceleration(10000);
  m4.setAcceleration(10000);

}

//----------------------------------------------------------------------------------------- 

void loop() {
  
  dados();
  velocidades();

}

//-----------------------------------------------------------------------------------------

void dados() {
  if (Bluetooth.available() > 0) {  //Recebe o byte do celular
    in_byte = Bluetooth.read(); //Armazane o byte em uma variável
    if (in_byte == (255)) {// Se a variável é 0 seta o índice do array para 0. Isso garante que cada número ocupe a posição correta.
      array_index = 0;
    }
    dataIn[array_index] = in_byte;  //Armazena o número em um array
    array_index = array_index + 1;
  }

  vx = float(dataIn[1]) - 100;
  vy = 100 - float(dataIn[2]);
  w =  float(dataIn[3]) - 100;
  est = dataIn[4];
  ang = dataIn[5];
  fire = dataIn[6];
}

void velocidades() {
  v1 = (vy + vx + w) * 8;
  v2 = (vy - vx + w) * 8;
  v3 = (vy - vx - w) * 8;
  v4 = (vy + vx + w) * 8;

  V1 = round(v1);
  V2 = round(v2);
  V3 = round(v3);
  V4 = round(v4);

  m1.setSpeed(V1);
  m2.setSpeed(V2);
  m3.setSpeed(V3);
  m4.setSpeed(V4);

  m1.runSpeed();
  m2.runSpeed();
  m3.runSpeed();
  m4.runSpeed();
}

//-----------------------------------------------------------------------------------------
